import { DirectiveWrapper } from '@aws-amplify/graphql-transformer-core';
import { TransformerBeforeStepContextProvider, TransformerContextProvider } from '@aws-amplify/graphql-transformer-interfaces';
import { ObjectTypeDefinitionNode } from 'graphql';
import { Construct } from 'constructs';
import { AuthProvider, AuthRule, ConfiguredAuthProviders, GetAuthRulesOptions } from './definitions';
import { RoleDefinition, RolesByProvider } from './role-definition';
export * from './constants';
export * from './definitions';
export * from './validations';
export * from './schema';
export * from './iam';
export * from './role-definition';
export declare const splitRoles: (roles: Array<RoleDefinition>) => RolesByProvider;
export declare const getAuthDirectiveRules: (authDir: DirectiveWrapper, options?: GetAuthRulesOptions) => AuthRule[];
export declare const getScopeForField: (ctx: TransformerContextProvider, obj: ObjectTypeDefinitionNode, fieldName: string, hasModelDirective: boolean) => Construct;
export declare const getConfiguredAuthProviders: (context: TransformerBeforeStepContextProvider) => ConfiguredAuthProviders;
export declare const isAuthProviderEqual: (provider: AuthProvider, otherProvider: AuthProvider) => boolean;
//# sourceMappingURL=index.d.ts.map