"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isDynamicAuthOrCustomAuth = exports.isFieldRoleHavingAccessToBothSide = exports.isIdenticalAuthRole = void 0;
const isIdenticalAuthRole = (role1, role2) => role1.provider === role2.provider &&
    role1.strategy === role2.strategy &&
    role1.static === role2.static &&
    role1.claim === role2.claim &&
    role1.entity === role2.entity;
exports.isIdenticalAuthRole = isIdenticalAuthRole;
const isFieldRoleHavingAccessToBothSide = (fieldRole, relatedModelRoles) => relatedModelRoles.some((relatedRole) => (0, exports.isIdenticalAuthRole)(relatedRole, fieldRole) ||
    (relatedRole.provider === fieldRole.provider &&
        (relatedRole.provider === 'userPools' || relatedRole.provider === 'oidc' || relatedRole.provider === 'identityPool') &&
        (fieldRole.strategy === 'private' || relatedRole.strategy === 'private')));
exports.isFieldRoleHavingAccessToBothSide = isFieldRoleHavingAccessToBothSide;
const isDynamicAuthOrCustomAuth = (role) => (role.static === false && (role.strategy === 'owner' || role.strategy === 'groups')) || role.strategy === 'custom';
exports.isDynamicAuthOrCustomAuth = isDynamicAuthOrCustomAuth;
//# sourceMappingURL=role-definition.js.map